#!/bin/sh

FicTemp="/tmp/`basename $0`.$$"

Exit ()
{
    rm -f $FicTemp $FicTemp.$$ $FicTemp.cmd $FicTemp.cmd.out $FicTemp.cron $FicTemp.edit
    exit
}

trap "Exit" 2 6 9 15

[ $# -lt 1 ] && echo >&2 "Usage : `basename $0` [ -m | -d | -v | -html ]" && Exit

while [ -n "$1" ]
do
    case "$1" in
        -html) HTML=y ;;
        -m) Action="modifier" ;;
        -v) Action="voir" ;;
        -d) Action="effacer" ;;
        *) echo >&2 "Usage : `basename $0` [ -m | -d | -v | -html ]" && Exit
    esac
    shift
done

GetCron ()
{
    crontab -l | grep "\[AGENDA] " | \
    sed -e "s/.* \* \(echo -e \".*\"\) | .*sendmail.sh.*/\1/" | \
    sort -n -t "/" -k 3 -k 2 -k 1 | \
    tee $FicTemp.cron | \
    /bin/sh > $FicTemp 2> /dev/null
    [ -s $FicTemp ] || Exit
}

if [ "$HTML" = "y" ]
then
    GetCron
    Nom=`grep "^$LOGNAME:" /etc/passwd | cut -d: -f5`
    [ -z "$Nom" ] && Nom=$LOGNAME
    cat << EOF
<html>
<head><title>Rendez-vous de $Nom</title></head>

<body bgcolor="#ffffff">
<h1>Rendez-vous de $Nom</h1>
<ul>
EOF
    egrep -v "From: " $FicTemp | \
    sed -e "s/^Subject: \[AGENDA] \([0-9][0-9]*\/[0-9][0-9]*\/[0-9][0-9]*\): \(.*\)/<li>\1 <b>\2<\/b>/" \
        -e "s/^To: /==> /" \
        -e "s/$/<br>/g" \
        -e "s/^\(<li>.*\)<br>$/<br>\1/" | \
    uniq
    cat << EOF
</ul>
<hr></hr>
<font size="-1">Page gnre le `date` par $LOGNAME@`hostname -f`</font>
</body>
</html>
EOF
    Exit
else
    while true
    do
        GetCron
        grep "^Subject: " $FicTemp | \
        sed "s/^Subject: \[AGENDA] \([0-9][0-9]*\/[0-9][0-9]*\/[0-9][0-9]*: .*\)/\"\1\" \\\/" |
        nl > $FicTemp.$$
        cat << EOF > $FicTemp.cmd
#!/bin/sh

cd \`dirname \$0\`

FicTemp="/tmp/\`basename \$0\`.\$\$"

Exit ()
{
    rm -f \$FicTemp
    exit 1
}

trap "Exit ; exit 0" 2 6 9 15

Xdialog --menubox "Quel est le RV a $Action ?" 15 70 8 \\
`cat \$FicTemp.\$\$`
2> \$FicTemp || Exit

cat \$FicTemp | grep -v "Gdk-WARNING" | tail -n 1 | sed "s;/; ;g"
rm -f \$FicTemp

EOF
        sh $FicTemp.cmd > $FicTemp.cmd.out || Exit
        reponse=`cat $FicTemp.cmd.out`

        if [ "$Action" = "voir" ]
        then
            cat $FicTemp.cron | \
            head -n $reponse | tail -n 1 | \
            /bin/sh | \
            egrep -v "^From: |^To: " | \
            sed "s/^Subject: \[AGENDA] [0-9][0-9]*\/[0-9][0-9]*\/[0-9][0-9]*: //" | \
            Xdialog --textbox - 15 70 || Exit
        elif [ "$Action" = "modifier" ]
        then
            cat $FicTemp.cron | \
            head -n $reponse | tail -n 1 | \
            sed -e "s/^echo -e \"Subject: \[AGENDA] [0-9][0-9]*\/[0-9][0-9]*\/[0-9][0-9]*: .*From: .*To: [^\\\]*\\\[n]\\\[n]\(.*\)\"/echo -e \"\1\"/" | \
            /bin/sh | \
            Xdialog --editbox - 15 70 2> $FicTemp.edit || Exit
            What=`cat $FicTemp.edit | \
                  sed -e "s/$/\\\\\n/" | \
                  tr -d '\n' | \
                  sed "s/\\\\\[n]$//"`
            (
            Id=`cat $FicTemp.cron | \
            head -n $reponse | tail -n 1 | \
            sed "s/.*Subject: \[AGENDA] \([0-9][0-9]*\/[0-9][0-9]*\/[0-9][0-9]*: .*\)\\\\\nFrom: .*/\1/"`
            crontab -l | egrep -v "^#|$Id"
            crontab -l | grep "$Id" > $FicTemp.edit
            Date=$1
            set -- `sed "s;^\([0-9][0-9]*\) \([0-9][0-9]*\) \([0-9][0-9]*\) \([0-9][0-9]*\) \* .*\[AGENDA] \([0-9][0-9]*\/[0-9][0-9]*\/[0-9][0-9]*\): \([^\\\]*\).*From: \([^\\\]*\)\\\\\.*;\1 \2 \3 \4 \5 \7 \6;" \
            < $FicTemp.edit`
            To=`sed "s;.*To: \([^\\\]*\)\\\\\.*;\1;" < $FicTemp.edit`
            Subject=`sed "s;.*\[AGENDA] [0-9][0-9]*\/[0-9][0-9]*\/[0-9][0-9]*: \([^\\\]*\).*;\1;" < $FicTemp.edit`
            [ -z "$LOGNAME" ] && LOGNAME=$USER
            cat << EOF
$1 $2 $3 $4 * echo -e "Subject: [AGENDA] $5: $Subject\nFrom: $LOGNAME@`hostname --fqdn`\nTo: `echo $To | sed -e "s/[ |,][ |,]*/, /g"`\n\n$What" | `pwd`/sendmail.sh `echo $To | sed -e "s/[ |,][ |,]*/ /g"`
EOF
            ) | crontab -
            rm -f $FicTemp.edit
        elif [ "$Action" = "effacer" ]
        then
            (
            Id=`cat $FicTemp.cron | \
            head -n $reponse | tail -n 1 | \
            sed "s/.*Subject: \[AGENDA] \([0-9][0-9]*\/[0-9][0-9]*\/[0-9][0-9]*: .*\)\\\\\nFrom: .*/\1/"`
            crontab -l | egrep -v "^#|$Id"
            ) | crontab -
        fi
    done
fi

Exit

