#!/bin/sh

cd `dirname $0`

DIALOG=Xdialog
FicTemp="/tmp/`basename $0`.$$"

Exit ()
{
    rm -f $FicTemp
    exit 1
}

trap "Exit ; Exit 0" 2 6 9 15

#
# Quelle date ?
#

$DIALOG --calendar "Please choose a date" 15 70 `date "+%d %m %Y"` 2> $FicTemp || Exit
Date=`cat $FicTemp`
_IFS="$IFS"
IFS="/"
set -- $Date
Day=$1
Month=$2
Year=$3
IFS="$_IFS"

#
# Quoi faire ?
#

Xdialog --inputbox "Subject" 15 70 2> $FicTemp || Exit
Subject=`cat $FicTemp`

Xdialog --editbox "What to do?" 15 70 2> $FicTemp || Exit
What=`cat $FicTemp | \
      sed -e "s/$/\\\\\n/" | \
      tr -d '\n'`

#
# Que faire ? Envoyer un mail a ...
#

Xdialog --inputbox "Send a mail to:" 15 70 2> $FicTemp || Exit
To=`cat $FicTemp`

#
# Quelle date envoyer le mail ?
#

$DIALOG --calendar "Please choose a date for the mail" 15 70 `./hier.sh $Day $Month $Year | tr '/' ' '` 2> $FicTemp || Exit
Date=`cat $FicTemp`
_IFS="$IFS"
IFS="/"
set -- $Date
DayE=$1
MonthE=$2
YearE=$3
IFS="$_IFS"

#
# A quelle heure faire le "quoi" ?
#

Xdialog --timebox "What time send mail to $To?" 15 70 2> $FicTemp || Exit
Time=`cat $FicTemp`
_IFS="$IFS"
IFS=":"
set -- $Time
H=$1
M=$2
IFS="$_IFS"

(
crontab -l | egrep -v "^#|\[AGENDA] $Date: $Subject\""

[ -z "$LOGNAME" ] && LOGNAME=$USER
cat << EOF
$M $H $DayE $MonthE * echo -e "Subject: [AGENDA] $Date: $Subject\nFrom: $LOGNAME@`hostname --fqdn`\nTo: `echo $To | sed -e "s/[ |,][ |,]*/, /g"`\n\n$What" | `pwd`/sendmail.sh `echo $To | sed -e "s/[ |,][ |,]*/ /g"`
EOF
) | crontab -

